#include <movingAvg.h>
#include <Wire.h>
#include <Servo.h>

#include <TimeLib.h>
#include <Time.h>
#include <DS1307RTC.h>

tmElements_t tm;

int i=0,
    k,
    
    hms1=1,
    hms2,
    hms3,
    j=0,
    amp,
    
    m,
    o,
    p,
    
    Pause1,
    Pause2,
    Pause3,
    LightTime,
    
    H = 11,          //   R
    M = 10,          //   B
    S = 12,          //    G
    Chk=A2,
    interruptPin = 2,
    
    HourV,
    MinV,
    SecV,
    fkt = 480;  //4*60,
    
bool fkt360[60];   
float    rpm  ;    
Servo Disk;
long int  avg10,avg11;   
int avg, c16;
movingAvg avgrpm(200),amp2(10);
unsigned long start,start2;


void setup() {
  
 Disk.attach(9);
   
 Serial.begin(250000);
 while (!Serial) ; // wait for serial
 

 Wire.begin();  
 avgrpm.begin();
 

 delay(300);
 Disk.write(0);
 delay(1200);
 Disk.write(95);

 pinMode(interruptPin, INPUT_PULLUP);
 attachInterrupt(digitalPinToInterrupt(interruptPin), blink, RISING ); 
 
pinMode(H, OUTPUT);
pinMode(M, OUTPUT);
pinMode(S, OUTPUT);

digitalWrite(H,HIGH);
digitalWrite(M,HIGH);
digitalWrite(S,HIGH);
}



void loop() 
{ 

  if(digitalRead(4)==HIGH)          // User input via capacitive button
  {
    delay(500);                     // capacitive button triggers it self, need to "keep button pressed" 0.5 seconds
    if(digitalRead(4)==HIGH)i++;    // 5 display Demos cycle
    if( i>5)i=0;
    o=(avg/fkt);
  }
  
    amp=(analogRead(A7)-512)*5;   // Read audio lvl
    
    if(amp<0)amp=amp*(-1);        // rectifie signal
    
    
       
    if(i==1&&m==1)  {Serial.print("1 ");AudioLvl();}    //  << dB-Meter
    
    if(i==2&&m==1)  {Serial.print("2 ");RGB13();}
    if(i==3&&m==1)  {Serial.print("3 ");Fader1();}  
     
   // if(i==4&&m==1)  {Serial.print("4 ");Second();}
   
    if(i==4&&m==1)  {Serial.print("5 ");RGB14();}
    if(i==5&&m==1)  {/*Serial.print("6 ")*/;Light();}
                
 /* 
  if (m==1)
  {
    o=((avg/fkt)); 
    // getTime();

    if(i==1)  Light();  
    if(i==2)  RGB13();
    if(i==3)  Fader1();   
    if(i==4)  Second();
    if(i==5)  RGB14();
   //   Minute();
    //  Hour();
   
    Serial.println(i); 
  
  }
  */ //Serial.println(i); 
}

void AudioLvl()
{
       if (amp < 0) amp = 0;
       if (amp > 400) amp = 400;    
        
       Serial.println(amp);    
       
      // amp2=amp;  
         
      digitalWrite(H,LOW);
      digitalWrite(M,LOW);
      digitalWrite(S,LOW); 
       
      delayMicroseconds((o*amp));     
          
      digitalWrite(H,HIGH);
      digitalWrite(S,HIGH);
      digitalWrite(M,HIGH);
      
      p = micros() - start2; 
      m=0;
}


void blink() 
{
//   rpm = 1000000000/(avg);
//   Serial.println(60*(rpm/1000),3); 

    k = micros() - start;    
    start = micros(); 
    m=1;      
    
    
    avg = avgrpm.reading(k);
    //Serial.println(avg);
    
}


void getTime ()
{
    tmElements_t tm;
    if (RTC.read(tm)) 
    {
    HourV = map(tm.Hour,0,23,fkt,0);  //HourV = map(tm.Hour,12,23,0,fkt);
    MinV = map(tm.Minute,0,59,fkt,0);
    SecV = map(tm.Second,0,59,fkt,0);
    
//    fkt360[HourV]=1;
//    fkt360[MinV]=1;
//    fkt360[SecV]=1;
    }
  }



void Light() 
{ 
      
      start2 = micros(); 
      getTime();
      LightTime=50;         

    //  o=((avg/fkt)-((avg/fkt/8))); 
            
      j++;
     
     if(hms3==1)  Hour(); 
     if(hms2==1)  Minute();    
     if(hms1==1)  Second();  
                    
//delayMicroseconds(SecV*o); 

//Zeiger1();

//delayMicroseconds(Pause2); 
//Hour();
//delayMicroseconds(Pause3); 
//Minute(); //Second();

//     printTime();
     
       p = micros() - start2; 
       m=0;
}


void printTime()
{
      Serial.print(tm.Hour);Serial.print(":");Serial.print(tm.Minute);Serial.print(":");Serial.println(tm.Second);
}


void Hour()
{  
      delayMicroseconds(HourV*o); 

      Zeiger1();
      digitalWrite(H,LOW);
      delayMicroseconds(LightTime);
      digitalWrite(H,HIGH);
      hms3=0;
      hms1=1;
      m=0;
  }

  
void Minute()
{ 
      delayMicroseconds(MinV*o); 

      Zeiger2();
      digitalWrite(M,LOW);
      delayMicroseconds(LightTime);   
      digitalWrite(M,HIGH); 
      hms2=0;
      hms3=1;
      m=0;
  }

  
void Second()
{          
      delayMicroseconds(SecV*o); 
      
      Zeiger1();
      digitalWrite(S,LOW);
      delayMicroseconds(LightTime);
      digitalWrite(S,HIGH);
      hms1=0;
      hms2=1;
      m=0;
}


void Fader1()
{     
      start2 = micros();
      if( p>avg){j=0;}
       
      digitalWrite(H,LOW);
      digitalWrite(M,LOW);
      digitalWrite(S,LOW); 
       
      delayMicroseconds((o*j));     
      delayMicroseconds(LightTime*4);  
          
      digitalWrite(H,HIGH);
      digitalWrite(S,HIGH);
      digitalWrite(M,HIGH);
      
      j++;
      p = micros() - start2; 
      m=0;
  }

void Zeiger1()
{
      digitalWrite(H,LOW);
      digitalWrite(M,LOW);
      digitalWrite(S,LOW);      
      delayMicroseconds(LightTime);      
      digitalWrite(H,HIGH);
      digitalWrite(S,HIGH);
      digitalWrite(M,HIGH);
     // m=0;
  }
  
void Zeiger2()
{
      digitalWrite(H,LOW);delayMicroseconds(LightTime/5);   
      digitalWrite(M,LOW);delayMicroseconds(LightTime/5);   
      digitalWrite(S,LOW);delayMicroseconds(LightTime/5);      
      digitalWrite(H,HIGH);delayMicroseconds(LightTime/5);   
      digitalWrite(S,HIGH);delayMicroseconds(LightTime/5);   
      digitalWrite(M,HIGH);
     // m=0;
  }
  
void RGB13()
{
      digitalWrite(H,LOW);
      delayMicroseconds(avg/3.15);
      digitalWrite(H,HIGH);
      
      digitalWrite(M,LOW);
      delayMicroseconds(avg/3.15);
      digitalWrite(M,HIGH);
      
      digitalWrite(S,LOW);
      delayMicroseconds(avg/3.15);
      digitalWrite(S,HIGH);
      m=0;  
  }
  
void RGB14()
{
      digitalWrite(H,LOW);
      delayMicroseconds(avg/3.15/2);
      digitalWrite(H,HIGH);delayMicroseconds(avg/3.15/2);
      
      digitalWrite(M,LOW);
      delayMicroseconds(avg/3.15/2);
      digitalWrite(M,HIGH);delayMicroseconds(avg/3.15/2);
      
      digitalWrite(S,LOW);
      delayMicroseconds(avg/3.15/2);
      digitalWrite(S,HIGH);delayMicroseconds(avg/3.15/2);
      m=0;  
  }  